Subject: [PATCH] ax25: Fix SIOCAX25GETINFO ioctl

From: Eric Dumazet <[email-masked]>
Date: Sun, 20 Sep 2009 18:32:55 +0200

Jan Rafaj a écrit :
> 
> Hello Eric,
> 
> Your commit 31e6d363abcd0d05766c82f1a9c905a4c974a199 introduces (among
> other things):
> 
> diff --git a/net/ax25/af_ax25.c b/net/ax25/af_ax25.c
> index 61b35b9..da0f64f 100644
> --- a/net/ax25/af_ax25.c
> +++ b/net/ax25/af_ax25.c
> @@ -1780,8 +1781,8 @@ static int ax25_ioctl(struct socket *sock,
> unsigned int cmd, unsigned long arg)
>                 ax25_info.idletimer =
> ax25_display_timer(&ax25->idletimer) / (60 * HZ);
>                 ax25_info.n2count   = ax25->n2count;
>                 ax25_info.state     = ax25->state;
> -               ax25_info.rcv_q     = atomic_read(&sk->sk_rmem_alloc);
> -               ax25_info.snd_q     = atomic_read(&sk->sk_wmem_alloc);
> +               ax25_info.rcv_q     = sk_wmem_alloc_get(sk);
> +               ax25_info.snd_q     = sk_rmem_alloc_get(sk);
>                 ax25_info.vs        = ax25->vs;
>                 ax25_info.vr        = ax25->vr;
>                 ax25_info.va        = ax25->va;
> 
> I believe there is a typo, correctly this should be:
> 
>                 ax25_info.idletimer = ax25_display_timer(&ax25->idletimer)
> / (60 * HZ);
>                 ax25_info.n2count   = ax25->n2count;
>                 ax25_info.state     = ax25->state;
> -               ax25_info.rcv_q     = atomic_read(&sk->sk_rmem_alloc);
> -               ax25_info.snd_q     = atomic_read(&sk->sk_wmem_alloc);
> +               ax25_info.rcv_q     = sk_rmem_alloc_get(sk);
> +               ax25_info.snd_q     = sk_wmem_alloc_get(sk);
>                 ax25_info.vs        = ax25->vs;
>                 ax25_info.vr        = ax25->vr;
>                 ax25_info.va        = ax25->va;
> 
> If this is not fixed in the master, then fix, please.
> 
> Being a total kernel newbie, I've checked it against Greg K-H's 2.6.31.y
> git tree (but I'm quite unsure whether this is the real HEAD of
> latest [most up to date] development master branch), so if you know where
> I should be looking instead, I'll be grateful for any kicking into the
> right direction... (I somehow feel this should probably be the main
> Linus's syndication tree linux/kernel/git/torvalds/linux-2.6.git - feel
> free to correct me on this one please).
> 
> Thanks,
> 
> Jan
> 
> ---
> Jan Rafaj
> University of Defence in Brno
> 

Oops, Jan you are absolutely right, this part of the patch was wrong.

Dont worry, David will push your patch to netdev tree, then to Linus.

Thanks

[PATCH] ax25: Fix SIOCAX25GETINFO ioctl

rcv_q & snd_q initializations were reversed in commit
31e6d363abcd0d05766c82f1a9c905a4c974a199
(net: correct off-by-one write allocations reports)

Signed-off-by: Jan Rafaj <[email-masked]>
Signed-off-by: Eric Dumazet <[email-masked]>
---
diff --git a/net/ax25/af_ax25.c b/net/ax25/af_ax25.c
index da0f64f..d6b1b05 100644
--- a/net/ax25/af_ax25.c
+++ b/net/ax25/af_ax25.c
@@ -1781,8 +1781,8 @@ static int ax25_ioctl(struct socket *sock, unsigned int cmd, unsigned long arg)
 		ax25_info.idletimer = ax25_display_timer(&ax25->idletimer) / (60 * HZ);
 		ax25_info.n2count   = ax25->n2count;
 		ax25_info.state     = ax25->state;
-		ax25_info.rcv_q     = sk_wmem_alloc_get(sk);
-		ax25_info.snd_q     = sk_rmem_alloc_get(sk);
+		ax25_info.rcv_q     = sk_rmem_alloc_get(sk);
+		ax25_info.snd_q     = sk_wmem_alloc_get(sk);
 		ax25_info.vs        = ax25->vs;
 		ax25_info.vr        = ax25->vr;
 		ax25_info.va        = ax25->va;